program rebuildXML;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes;

var
  pXML, oXML : TMemoryStream;

// Recursive
procedure ParseChild(Lvl: LongWord; Src, Dst : TMemoryStream);
  function ReadStr(Frm : TMemoryStream) : String;
  var
    Len : LongWord;
    Res : array of Char;
  begin
    Result := '';
    Frm.Read(Len, 4);
    if Len > 0 then
    begin
      setLength(Res, Len);
      Frm.Read(pchar(Res)^, Len);
      result := string(res);
    end;
  end;

var
  NodeName,
  Name,
  Value,
  Tmp      : String;
  i,
  Attribs,
  Values,
  Children : LongWord;

begin

  NodeName := ReadStr(Src);
  Src.Read(Attribs, 4);

  if Attribs > 0 then
  begin
    write('Not sure how to handle attributes');
    exit;
  end;

  Tmp := Format('%*s<%s>', [Lvl*2, '', NodeName]) + #13#10;
  Dst.Write(Tmp[1], Length(Tmp));

  Src.Read(Values, 4);

  for i := 1 to Values do
  begin
    Name  := ReadStr(Src);
    Value := ReadStr(Src);

    Tmp := Format('%*s<%s>%s</%s>', [(Lvl+1)*2, '', Name, Value, Name]) + #13#10;
    Dst.Write(Tmp[1], Length(Tmp));

  end;

  Src.Read(Children, 4);

  for i := 1 to Children do
    ParseChild(Lvl+1, Src, Dst);

  Tmp := Format('%*s</%s>', [Lvl*2, '', NodeName]) + #13#10;
  Dst.Write(Tmp[1], Length(Tmp));

end;

begin

  Write('Stray Souls XML Rebuilder'#13#10'By WRS (xentax.com'#13#10#13#10);


  pXML := TMemoryStream.Create;

  if paramcount <> 1 then
  begin
    Write('Usage: '+extractfilename(paramstr(0))+ ' <filename>'#13#10#13#10);
    Exit;
  end;

  try
    pXML.LoadFromFile(ParamStr(1));
    Write('Loaded file (' + inttostr(pXML.Size) + ' bytes)!'#13#10#13#10);
  except
    Write('Cannot load file!'#13#10#13#10);
    Exit;
  end;

  oXML := TMemoryStream.Create;

  Write('Working, please wait...'#13#10#13#10);

  ParseChild(0, pXML, oXML);

  Write('Done (' + inttostr(oxml.Size) + ' bytes)!'#13#10#13#10);


  oXML.SaveToFile(extractfilename(paramstr(1))+'.xml');
  oXML.Free;
  pXML.Free;

  Write('Press ENTER to exit...');
  readln;

end.
